window.Gleam.initSearch([{"doc":"releam","title":"releam","content":"# releam\n\n[![Package Version](https://img.shields.io/hexpm/v/releam)](https://hex.pm/packages/releam)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/releam/)\n\nReleam is an opinionated gleam package release CLI tool and also a set of utilities for parsing conventional commits.\nIt is based on the semver and conventional commit specs. Invalid conventional commits will be ignored by this tool.\n\nIt is highly inspired by [unjs/changelogen](https://github.com/unjs/changelogen), shoutout to the unjs team for the amazing work in JS land ! You can expect more features comming from this tool in the future.\n\n## Install\n```sh\ngleam add --dev releam\n```\n\n## Usage\nOnce you are ready to create a new release from your main git branch, run the following :\n```sh\ngleam run -m releam\n```\nIt will :\n- parse the new commits since the last git tag\n- bump your package version\n- generate a changelog based on your conventional commits messages\n- prepend the changelog to your `CHANGELOG.md` (if it&#39;s missing it will create it)\n- create a release commit and a new tag\n- if your repository host is supported, it will print a link to your terminal to create a new release (currently only github is supported)\n\nIf you have specific requirements, this package exposes all its internal function for you to build your custom release script.\n\n## Configuration\nYou can configure automatic git push when running releam by adding this to your `gleam.toml` :\n```toml\n[releam]\nauto_push = true\n```\nBy default, auto push is disabled.\n\n## Documentation\nFurther documentation can be found at &lt;https://hexdocs.pm/releam&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\n```\n","url":"index.html"},{"doc":"releam/commit_regex","title":"git_log_commit_re","content":"pub const git_log_commit_re: String\n\nSynonyms:\nreleam/commit_regex.git_log_commit_re\nreleam/commit_regex git_log_commit_re","url":"releam/commit_regex.html#git_log_commit_re"},{"doc":"releam/commit_regex","title":"releam/commit_regex","content":"","url":"releam/commit_regex.html"},{"doc":"releam/conventional_attributes","title":"CommitType","content":"pub type CommitType {\n  Feat\n  Perf\n  Fix\n  Refactor\n  Docs\n  Build\n  Style\n  Test\n  Ci\n  Chore\n  Custom(String)\n}\n\nFeat\n\n\nPerf\n\n\nFix\n\n\nRefactor\n\n\nDocs\n\n\nBuild\n\n\nStyle\n\n\nTest\n\n\nCi\n\n\nChore\n\n\nCustom(String)\n\n\nSynonyms:\nreleam/conventional_attributes.CommitType\nreleam/conventional_attributes CommitType","url":"releam/conventional_attributes.html#CommitType"},{"doc":"releam/conventional_attributes","title":"ConventionalAttributes","content":"pub type ConventionalAttributes {\n  ConventionalAttributes(\n    commit_type: CommitType,\n    scope: Option(String),\n    description: String,\n    body: List(String),\n    footer: List(#(String, String)),\n    breaking: Bool,\n  )\n}\n\nConventionalAttributes(\n  commit_type: CommitType,\n  scope: Option(String),\n  description: String,\n  body: List(String),\n  footer: List(#(String, String)),\n  breaking: Bool,\n)\n\n\nSynonyms:\nreleam/conventional_attributes.ConventionalAttributes\nreleam/conventional_attributes ConventionalAttributes","url":"releam/conventional_attributes.html#ConventionalAttributes"},{"doc":"releam/conventional_attributes","title":"ConventionalCommitParseError","content":"pub type ConventionalCommitParseError {\n  InvalidCommitDefinition\n  InvalidCommitMessage\n}\n\nInvalidCommitDefinition\n\n\nInvalidCommitMessage\n\n\nSynonyms:\nreleam/conventional_attributes.ConventionalCommitParseError\nreleam/conventional_attributes ConventionalCommitParseError","url":"releam/conventional_attributes.html#ConventionalCommitParseError"},{"doc":"releam/conventional_attributes","title":"ConventionalDefinition","content":"pub type ConventionalDefinition {\n  ConventionalDefinition(\n    commit_type: CommitType,\n    scope: Option(String),\n    description: String,\n    breaking: Bool,\n  )\n}\n\nConventionalDefinition(\n  commit_type: CommitType,\n  scope: Option(String),\n  description: String,\n  breaking: Bool,\n)\n\n\nSynonyms:\nreleam/conventional_attributes.ConventionalDefinition\nreleam/conventional_attributes ConventionalDefinition","url":"releam/conventional_attributes.html#ConventionalDefinition"},{"doc":"releam/conventional_attributes","title":"ConventionalFooterParseError","content":"pub type ConventionalFooterParseError {\n  InvalidConventionalFooter\n  InvalidConventionalFooterLine\n}\n\nInvalidConventionalFooter\n\n\nInvalidConventionalFooterLine\n\n\nSynonyms:\nreleam/conventional_attributes.ConventionalFooterParseError\nreleam/conventional_attributes ConventionalFooterParseError","url":"releam/conventional_attributes.html#ConventionalFooterParseError"},{"doc":"releam/conventional_attributes","title":"ConventionalOptionalSections","content":"pub type ConventionalOptionalSections {\n  ConventionalOptionalSections(\n    body: List(String),\n    footer: List(#(String, String)),\n    breaking: Bool,\n  )\n}\n\nConventionalOptionalSections(\n  body: List(String),\n  footer: List(#(String, String)),\n  breaking: Bool,\n)\n\n\nSynonyms:\nreleam/conventional_attributes.ConventionalOptionalSections\nreleam/conventional_attributes ConventionalOptionalSections","url":"releam/conventional_attributes.html#ConventionalOptionalSections"},{"doc":"releam/conventional_attributes","title":"parse_attributes","content":"pub fn parse_attributes(\n  message: String,\n) -&gt; Result(ConventionalAttributes, ConventionalCommitParseError)\n Parses a commit message to a ConventionalAttributes record\nSynonyms:\nreleam/conventional_attributes.parse_attributes\nreleam/conventional_attributes parse_attributes","url":"releam/conventional_attributes.html#parse_attributes"},{"doc":"releam/conventional_attributes","title":"parse_commit_type","content":"pub fn parse_commit_type(commit_type: String) -&gt; CommitType\n\nSynonyms:\nreleam/conventional_attributes.parse_commit_type\nreleam/conventional_attributes parse_commit_type","url":"releam/conventional_attributes.html#parse_commit_type"},{"doc":"releam/conventional_attributes","title":"parse_definition","content":"pub fn parse_definition(\n  def: String,\n) -&gt; Result(ConventionalDefinition, ConventionalCommitParseError)\n Parses the first line of commit message to extract\n commit type, scope and description\nSynonyms:\nreleam/conventional_attributes.parse_definition\nreleam/conventional_attributes parse_definition","url":"releam/conventional_attributes.html#parse_definition"},{"doc":"releam/conventional_attributes","title":"parse_footer","content":"pub fn parse_footer(\n  raw: String,\n) -&gt; Result(List(#(String, String)), ConventionalFooterParseError)\n Parses a commit message footer to a dict\nSynonyms:\nreleam/conventional_attributes.parse_footer\nreleam/conventional_attributes parse_footer","url":"releam/conventional_attributes.html#parse_footer"},{"doc":"releam/conventional_attributes","title":"parse_optional_sections","content":"pub fn parse_optional_sections(\n  sections: List(String),\n) -&gt; ConventionalOptionalSections\n Parses the optional lines of a commit message to extract body and footer.\n The list must not include the first line of a commit message\nSynonyms:\nreleam/conventional_attributes.parse_optional_sections\nreleam/conventional_attributes parse_optional_sections","url":"releam/conventional_attributes.html#parse_optional_sections"},{"doc":"releam/conventional_attributes","title":"releam/conventional_attributes","content":"","url":"releam/conventional_attributes.html"},{"doc":"releam/commit","title":"Author","content":"pub type Author {\n  Author(name: String, email: String)\n}\n\nAuthor(name: String, email: String)\n\n\nSynonyms:\nreleam/commit.Author\nreleam/commit Author","url":"releam/commit.html#Author"},{"doc":"releam/commit","title":"Commit","content":"pub type Commit {\n  Commit(\n    hash: String,\n    short_hash: String,\n    author: Author,\n    date: String,\n    conventional_attributes: ConventionalAttributes,\n  )\n}\n\nCommit(\n  hash: String,\n  short_hash: String,\n  author: Author,\n  date: String,\n  conventional_attributes: ConventionalAttributes,\n)\n\n\nSynonyms:\nreleam/commit.Commit\nreleam/commit Commit","url":"releam/commit.html#Commit"},{"doc":"releam/commit","title":"CommitParseError","content":"pub type CommitParseError {\n  InvalidCommit(String)\n  InvalidConventionalAttributes(String)\n}\n\nInvalidCommit(String)\n\n\nInvalidConventionalAttributes(String)\n\n\nSynonyms:\nreleam/commit.CommitParseError\nreleam/commit CommitParseError","url":"releam/commit.html#CommitParseError"},{"doc":"releam/commit","title":"group_by_commit_type","content":"pub fn group_by_commit_type(\n  commits: List(Commit),\n) -&gt; List(#(CommitType, List(Commit)))\n Groups commits by their conventional commit type\nSynonyms:\nreleam/commit.group_by_commit_type\nreleam/commit group_by_commit_type","url":"releam/commit.html#group_by_commit_type"},{"doc":"releam/commit","title":"parse_list","content":"pub fn parse_list(commits: List(String)) -&gt; List(Commit)\n Parses a list of commits from the `git log` output to a list of Commit records\nSynonyms:\nreleam/commit.parse_list\nreleam/commit parse_list","url":"releam/commit.html#parse_list"},{"doc":"releam/commit","title":"parse_one","content":"pub fn parse_one(raw: String) -&gt; Result(Commit, CommitParseError)\n Parses a string commit from the `git log` output to a Commit record\nSynonyms:\nreleam/commit.parse_one\nreleam/commit parse_one","url":"releam/commit.html#parse_one"},{"doc":"releam/commit","title":"releam/commit","content":"","url":"releam/commit.html"},{"doc":"releam/package_config","title":"PackageConfig","content":"pub type PackageConfig {\n  PackageConfig(\n    version: SemVer,\n    repository: Result(Repository, Nil),\n    auto_push: Bool,\n  )\n}\n\nPackageConfig(\n  version: SemVer,\n  repository: Result(Repository, Nil),\n  auto_push: Bool,\n)\n\n\nSynonyms:\nreleam/package_config.PackageConfig\nreleam/package_config PackageConfig","url":"releam/package_config.html#PackageConfig"},{"doc":"releam/package_config","title":"Repository","content":"pub type Repository {\n  Repository(host: RepositoryHost, org: String, name: String)\n}\n\nRepository(host: RepositoryHost, org: String, name: String)\n\n\nSynonyms:\nreleam/package_config.Repository\nreleam/package_config Repository","url":"releam/package_config.html#Repository"},{"doc":"releam/package_config","title":"RepositoryHost","content":"pub type RepositoryHost {\n  Github\n  NotImplemented(String)\n}\n\nGithub\n\n\nNotImplemented(String)\n\n\nSynonyms:\nreleam/package_config.RepositoryHost\nreleam/package_config RepositoryHost","url":"releam/package_config.html#RepositoryHost"},{"doc":"releam/package_config","title":"parse","content":"pub fn parse(raw_config: String) -&gt; PackageConfig\n Parses the content of a gleam.toml to return a PackageConfig\nSynonyms:\nreleam/package_config.parse\nreleam/package_config parse","url":"releam/package_config.html#parse"},{"doc":"releam/package_config","title":"replace_version","content":"pub fn replace_version(\n  raw_config: String,\n  new_version: SemVer,\n) -&gt; String\n Replace the package version in a gleam.toml content\nSynonyms:\nreleam/package_config.replace_version\nreleam/package_config replace_version","url":"releam/package_config.html#replace_version"},{"doc":"releam/package_config","title":"releam/package_config","content":"","url":"releam/package_config.html"},{"doc":"releam/changelog","title":"Changelog","content":"pub type Changelog {\n  Changelog(\n    title: String,\n    compare_link: Result(String, Nil),\n    sections: List(Section),\n  )\n}\n\nChangelog(\n  title: String,\n  compare_link: Result(String, Nil),\n  sections: List(Section),\n)\n\n\nSynonyms:\nreleam/changelog.Changelog\nreleam/changelog Changelog","url":"releam/changelog.html#Changelog"},{"doc":"releam/changelog","title":"ChangelogConfig","content":"pub type ChangelogConfig {\n  ChangelogConfig(previous_tag: String, new_tag: String)\n}\n\nChangelogConfig(previous_tag: String, new_tag: String)\n\n\nSynonyms:\nreleam/changelog.ChangelogConfig\nreleam/changelog ChangelogConfig","url":"releam/changelog.html#ChangelogConfig"},{"doc":"releam/changelog","title":"Section","content":"pub type Section {\n  Section(header: CommitType, body: List(Commit))\n}\n\nSection(header: CommitType, body: List(Commit))\n\n\nSynonyms:\nreleam/changelog.Section\nreleam/changelog Section","url":"releam/changelog.html#Section"},{"doc":"releam/changelog","title":"changelog_file_path","content":"pub const changelog_file_path: String\n\nSynonyms:\nreleam/changelog.changelog_file_path\nreleam/changelog changelog_file_path","url":"releam/changelog.html#changelog_file_path"},{"doc":"releam/changelog","title":"init_changelog_file","content":"pub fn init_changelog_file() -&gt; Result(Nil, FileError)\n Creates a CHANGELOG.md file with a title and the insert area comment.\n Insert area comment is used by releam to inject new releases changelogs\n after the title and before the previous release changelog\nSynonyms:\nreleam/changelog.init_changelog_file\nreleam/changelog init_changelog_file","url":"releam/changelog.html#init_changelog_file"},{"doc":"releam/changelog","title":"new","content":"pub fn new(\n  package_config: PackageConfig,\n  config: ChangelogConfig,\n  commits: List(Commit),\n) -&gt; Changelog\n Generate a Changelog record\nSynonyms:\nreleam/changelog.new\nreleam/changelog new","url":"releam/changelog.html#new"},{"doc":"releam/changelog","title":"render","content":"pub fn render(\n  changelog: Changelog,\n  with_title with_title: Bool,\n) -&gt; String\n Renders a changelog to markdown\nSynonyms:\nreleam/changelog.render\nreleam/changelog render","url":"releam/changelog.html#render"},{"doc":"releam/changelog","title":"render_commit","content":"pub fn render_commit(commit: Commit) -&gt; String\n Renders a commit to markdown as a list item\nSynonyms:\nreleam/changelog.render_commit\nreleam/changelog render_commit","url":"releam/changelog.html#render_commit"},{"doc":"releam/changelog","title":"write_to_changelog_file","content":"pub fn write_to_changelog_file(\n  changelog: Changelog,\n) -&gt; Result(Nil, FileError)\n Renders a changelog and inject it to the CHANGELOG.md file.\n If the file does not exists yet, it will create it.\nSynonyms:\nreleam/changelog.write_to_changelog_file\nreleam/changelog write_to_changelog_file","url":"releam/changelog.html#write_to_changelog_file"},{"doc":"releam/changelog","title":"releam/changelog","content":"","url":"releam/changelog.html"},{"doc":"releam/git","title":"commit_release","content":"pub fn commit_release(new_tag: String, push push: Bool) -&gt; Nil\n Creates a release commit containing the CHANGELOG.md file and the gleam.toml\n with bumped version, creates the new tag and optionaly push to the git\n repository\nSynonyms:\nreleam/git.commit_release\nreleam/git commit_release","url":"releam/git.html#commit_release"},{"doc":"releam/git","title":"get_commits_since_last_tag","content":"pub fn get_commits_since_last_tag(tag: String) -&gt; List(String)\n Gets all commits since the last tag of the repository\nSynonyms:\nreleam/git.get_commits_since_last_tag\nreleam/git get_commits_since_last_tag","url":"releam/git.html#get_commits_since_last_tag"},{"doc":"releam/git","title":"get_last_tag","content":"pub fn get_last_tag() -&gt; String\n Gets the last tag of the repository\nSynonyms:\nreleam/git.get_last_tag\nreleam/git get_last_tag","url":"releam/git.html#get_last_tag"},{"doc":"releam/git","title":"releam/git","content":"","url":"releam/git.html"},{"doc":"releam/release","title":"generate_repository_host_release_link","content":"pub fn generate_repository_host_release_link(\n  package_config: PackageConfig,\n  new_changelog: Changelog,\n) -&gt; Result(String, Nil)\n Generates the new release link for supported repository hosts\nSynonyms:\nreleam/release.generate_repository_host_release_link\nreleam/release generate_repository_host_release_link","url":"releam/release.html#generate_repository_host_release_link"},{"doc":"releam/release","title":"releam/release","content":"","url":"releam/release.html"},{"doc":"releam/semver","title":"Bump","content":"pub type Bump {\n  Bump(major: Bool, minor: Bool, patch: Bool)\n}\n\nBump(major: Bool, minor: Bool, patch: Bool)\n\n\nSynonyms:\nreleam/semver.Bump\nreleam/semver Bump","url":"releam/semver.html#Bump"},{"doc":"releam/semver","title":"BumpType","content":"pub type BumpType {\n  Major\n  Minor\n  Patch\n}\n\nMajor\n\n\nMinor\n\n\nPatch\n\n\nSynonyms:\nreleam/semver.BumpType\nreleam/semver BumpType","url":"releam/semver.html#BumpType"},{"doc":"releam/semver","title":"define_bump_type","content":"pub fn define_bump_type(\n  commits: List(Commit),\n) -&gt; Option(BumpType)\n Defines a semver bump type from a list of commits\nSynonyms:\nreleam/semver.define_bump_type\nreleam/semver define_bump_type","url":"releam/semver.html#define_bump_type"},{"doc":"releam/semver","title":"define_commit_bump_type","content":"pub fn define_commit_bump_type(\n  current: Commit,\n) -&gt; Option(BumpType)\n Defines a semver bump type according to the commit type\nSynonyms:\nreleam/semver.define_commit_bump_type\nreleam/semver define_commit_bump_type","url":"releam/semver.html#define_commit_bump_type"},{"doc":"releam/semver","title":"update_bump","content":"pub fn update_bump(bump: Bump, update: Option(BumpType)) -&gt; Bump\n\nSynonyms:\nreleam/semver.update_bump\nreleam/semver update_bump","url":"releam/semver.html#update_bump"},{"doc":"releam/semver","title":"releam/semver","content":"","url":"releam/semver.html"},{"doc":"releam","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nreleam.main\nreleam main","url":"releam.html#main"},{"doc":"releam","title":"releam","content":"","url":"releam.html"}]);